goog.provide('ttg.dash.srp');

goog.require('goog.array');
goog.require('goog.dom');
goog.require('goog.events');
goog.require('goog.net.Jsonp');
goog.require('goog.Timer');

ttg.dash.srp.send = function() {
    var domain = document.domain;
    if (domain == 'localhost') { domain = 'localhost:8080'; }
    var jsonp = new goog.net.Jsonp('http://' + domain + '/dashboard.json');
    jsonp.send({},
	       ttg.dash.srp.handleResponse_, 
	       ttg.dash.srp.handleError_);
};

ttg.dash.srp.acts = [
    'example',
    'offbeats',
    'teuton',
    'crossword',
    'rebus',
    'sudoku',
    'onestepbeyond',
    'flags',
    'richmond',
    'march',
    'checkmate',
    'dualtone',
    'meta'
];

// var j = [{"status": "example\tsolved\t0\t0\t2010\/03\/16 21:57:02\noffbeats\tunlocked\t0\t0\t2010\/03\/16 21:57:02\ndualtone\tsolved\t0\t0\t2010\/03\/16 21:58:22\nteuton\tunlocked\t0\t0\t2010\/03\/16 21:58:22", "score": 1400, "id": "https:\/\/me.yahoo.com\/a\/qM8ZnNM8u4ypbhCI5e_lLj4K5yGDarE-#20c73"}, {"status": "example\tsolved\t0\t0\t2010\/03\/16 21:57:10\noffbeats\tunlocked\t0\t0\t2010\/03\/16 21:57:10\ndualtone\tsolved\t0\t0\t2010\/03\/16 21:58:09\nteuton\tunlocked\t0\t0\t2010\/03\/16 21:58:09", "score": 1400, "id": "http:\/\/lahosken.san-francisco.ca.us\/"}, {"status": "offbeats\tunlocked\t0\t0\t2010\/03\/13 00:42:31\nteuton\tunlocked\t0\t0\t2010\/03\/13 00:42:32\nexample\tsolved\t10\t1503\t2010\/03\/13 00:42:40\ncrossword\tunlocked\t0\t0\t2010\/03\/13 00:42:40", "score": 800, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawmRdMk-OmPrSNPG8PFNO_0km0EW8S5AfaY"}, {"status": "example\tsolved\t0\t0\t2010\/03\/07 19:39:39\noffbeats\tsolved\t0\t0\t2010\/03\/07 20:07:09\nteuton\tsolved\t0\t0\t2010\/03\/07 20:21:02\ncheckmate\tsolved\t110\t200\t2010\/03\/07 22:23:27\ncrossword\tsolved\t0\t0\t2010\/03\/07 22:23:59\nonestepbeyond\tsolved\t140\t241\t2010\/03\/08 00:36:59\nsudoku\tsolved\t0\t0\t2010\/03\/08 01:36:16\nrebus\tsolved\t50\t210\t2010\/03\/08 02:01:12\nmarch\tunlocked\t0\t0\t2010\/03\/08 02:01:12\nflags\tsolved\t0\t0\t2010\/03\/08 02:14:30\ndualtone\tunlocked\t0\t0\t2010\/03\/08 02:14:30\nrichmond\tsolved\t0\t0\t2010\/03\/08 02:21:50\nmeta\tsolved\t0\t0\t2010\/03\/08 02:56:29", "score": 1700, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawnlJg8bQTD0P2YtuqLZ2lf4U-gTCcvlng8"}, {"status": "example\tsolved\t0\t0\t2010\/03\/06 18:32:43\nteuton\tsolved\t0\t0\t2010\/03\/06 18:58:37\noffbeats\tsolved\t0\t90\t2010\/03\/06 19:13:08\ncrossword\tsolved\t0\t60\t2010\/03\/06 20:04:20\nsudoku\tsolved\t0\t0\t2010\/03\/06 21:04:02\nrichmond\tsolved\t0\t0\t2010\/03\/06 21:37:24\nonestepbeyond\tsolved\t0\t0\t2010\/03\/06 23:19:16\ncheckmate\tsolved\t90\t297\t2010\/03\/07 01:20:02\nmarch\tsolved\t0\t0\t2010\/03\/07 02:35:40\nrebus\tsolved\t0\t0\t2010\/03\/07 07:11:16\ndualtone\tsolved\t0\t0\t2010\/03\/07 07:11:25\nflags\tsolved\t0\t0\t2010\/03\/07 07:11:42\nmeta\tsolved\t0\t0\t2010\/03\/07 07:12:39", "score": 1700, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawlniCk-mSVUQ7qwMwMxLiYYrSprlMOemL8"}, {"status": "example\tsolved\t0\t0\t2010\/02\/27 18:38:36\ncrumble\tsolved\t0\t0\t2010\/02\/27 18:52:20\nnonogram\tsolved\t0\t80\t2010\/02\/27 19:47:08\nsudoku\tsolved\t0\t100\t2010\/02\/27 20:10:11\nrebus\tsolved\t0\t0\t2010\/02\/27 21:00:07\nrichmond\tsolved\t133\t133\t2010\/02\/27 21:33:36\nflags\tsolved\t0\t0\t2010\/02\/27 21:46:07\noffbeats\tsolved\t0\t0\t2010\/02\/27 22:11:07\nmarch\tsolved\t10\t87\t2010\/02\/27 23:17:26\ndualtone\tsolved\t0\t190\t2010\/02\/28 00:01:17\ncrossword\tsolved\t0\t0\t2010\/03\/05 04:22:35\nteuton\tsolved\t0\t100\t2010\/03\/05 04:45:05\nmeta\tsolved\t0\t0\t2010\/03\/05 08:12:55\ncheckmate\tsolved\t150\t629\t2010\/03\/05 08:34:13\nonestepbeyond\tsolved\t190\t741\t2010\/03\/06 20:43:46", "score": 1864, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawmf9amTgOeBJFR0fEeUU9ZPsqjnE0vs4r0"}, {"status": "example\tsolved\t0\t0\t2010\/02\/28 18:37:05\ncrossword\tsolved\t1\t62\t2010\/02\/28 19:30:38\nteuton\tsolved\t10\t47\t2010\/02\/28 19:39:50\nsudoku\tsolved\t0\t100\t2010\/02\/28 20:17:30\nrichmond\tsolved\t5\t7\t2010\/02\/28 20:25:36\nrebus\tsolved\t70\t81\t2010\/02\/28 20:55:05\nflags\tsolved\t30\t33\t2010\/02\/28 21:46:31\nonestepbeyond\tsolved\t100\t103\t2010\/02\/28 22:07:55\nnonogram\tsolved\t70\t157\t2010\/02\/28 23:12:03\nmarch\tsolved\t130\t199\t2010\/03\/01 01:31:56\ncheckmate\tsolved\t160\t161\t2010\/03\/01 01:37:59\noffbeats\tsolved\t0\t90\t2010\/03\/01 02:07:39\ndualtone\tsolved\t112\t190\t2010\/03\/01 02:18:55\nmeta\tsolved\t0\t0\t2010\/03\/01 03:05:01", "score": 1800, "id": "http:\/\/987s.livejournal.com\/"}, {"status": "example\tunlocked\t0\t0\t2010\/02\/27 03:34:57", "score": 500, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawkGfYF_BL2vDybprN17jHcrdVo5-Tfgpy4"}, {"status": "example\tsolved\t20\t20\t2009\/12\/24 19:04:11\ndualtone\tsolved\t0\t0\t2009\/12\/24 20:23:39\noffbeats\tsolved\t0\t0\t2009\/12\/24 21:42:33\nnonogram\tsolved\t0\t0\t2009\/12\/24 23:24:03\nrebus\tsolved\t330\t330\t2009\/12\/25 00:11:30\nflags\tsolved\t45\t452\t2009\/12\/26 08:18:24\nstroll\tsolved\t10\t1244\t2009\/12\/27 20:08:50\ncrossword\tsolved\t0\t0\t2009\/12\/27 22:39:03\nsteps\tsolved\t0\t0\t2009\/12\/27 22:39:19\nsudoku\tsolved\t0\t0\t2009\/12\/27 23:08:15\nteuton\tsolved\t0\t0\t2009\/12\/28 00:57:22\nrichmond\tsolved\t120\t120\t2009\/12\/28 08:19:05\ncrumble\tsolved\t0\t0\t2009\/12\/28 09:01:18\ncheckmate\tsolved\t0\t0\t2010\/01\/06 17:08:59\nmarch\tsolved\t0\t0\t2010\/01\/07 04:07:54\nonestepbeyond\tsolved\t0\t0\t2010\/01\/08 02:48:12", "score": 1337, "id": "https:\/\/me.yahoo.com\/a\/I_cX4qUwmeIZtb15jwpcmBNpakdTfLo-#65e2c"}, {"status": "example\tsolved\t5\t5\t2010\/01\/03 18:30:53\noffbeats\tunlocked\t0\t0\t2010\/01\/03 18:30:53\nrebus\tsolved\t0\t0\t2010\/01\/07 04:42:51\nrichmond\tunlocked\t0\t0\t2010\/01\/07 04:42:51\nnonogram\tsolved\t0\t0\t2010\/01\/07 04:43:08\nflags\tunlocked\t0\t0\t2010\/01\/07 04:43:08", "score": 1337, "id": "https:\/\/me.yahoo.com\/a\/AF_I3dpuos6n_QPzwhNngJlWhE5f#59cb3"}, {"status": "example\tsolved\t0\t0\t2009\/12\/24 17:22:31\nrebus\tsolved\t0\t0\t2009\/12\/26 15:59:50\nnonogram\tsolved\t60\t60\t2009\/12\/27 16:50:24\nflags\tunlocked\t0\t0\t2009\/12\/27 16:50:24\noffbeats\tsolved\t0\t0\t2009\/12\/27 21:17:00\nsteps\tsolved\t0\t0\t2009\/12\/27 21:18:19\ncrumble\tsolved\t0\t0\t2009\/12\/28 01:53:15\ncheckmate\tunlocked\t0\t0\t2009\/12\/28 01:53:15\ncrossword\tsolved\t0\t0\t2009\/12\/28 01:53:26\nteuton\tsolved\t0\t0\t2009\/12\/28 01:53:38\nsudoku\tsolved\t0\t0\t2009\/12\/28 01:53:46\nstroll\tsolved\t0\t0\t2009\/12\/28 01:53:57\nrichmond\tunlocked\t0\t0\t2009\/12\/28 01:53:57", "score": 1337, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawmpbZmvnkV21j-t6Lvgm7X9cWWAG0ID9pM"}, {"status": "example\tsolved\t0\t0\t2009\/12\/27 06:35:34\nrebus\tunlocked\t15\t15\t2009\/12\/27 06:46:19\noffbeats\tsolved\t0\t0\t2009\/12\/27 07:12:00\nnonogram\tunlocked\t0\t0\t2009\/12\/27 07:12:00", "score": 1337, "id": "https:\/\/www.google.com\/accounts\/o8\/id?id=AItOawlAxvqV_yW10qjKZKlWr4wqslN2Zvf53iw"}];

ttg.dash.srp.handleResponse_ = function(ary) {
    var put = goog.dom.getElement("recent_teams")
    if (!put) { return; }
    goog.dom.removeChildren(put);
    var key;
    var tr = goog.dom.createDom('tr', {}, 
				goog.dom.createDom('td'),
				goog.dom.createDom('td'),
				key = goog.dom.createDom('td'));
    key.innerHTML = '<tt>xo&euml;&dagger;&hearts;s1frmcdm';
    goog.dom.appendChild(put, tr);
    goog.array.forEach(ary, function(p) {
	    var color = 'ffffff' + p.id.toLowerCase().split(/[^a-fA-F]+/).join('');
	    color = color.slice(-6);
            var status_bar;
	    var d = goog.dom.createDom('tr', {}, 
				       goog.dom.createDom('td', { 'style': 'font-size: small; background-color: #' + color + ';' }, goog.dom.createDom('a', { 'href': 'adm/pl?id=' + encodeURIComponent(p.id)}, p.id.replace('www.', '').replace('.com/', '/').replace('/accounts/o8/', '/') )), 
              goog.dom.createDom('td', {}, '' + p['score'] ), 
              status_bar = goog.dom.createDom('td', {}, '' ));
            var status_l = p['status'].split('\n');
            var status_s = '<tt>';
            var background_b = 0;
            var background_g = 0;
            goog.array.forEach(ttg.dash.srp.acts, function(a) {
		    background_b += 7;
		    background_g += 3;
		    if (background_b > 9) { background_b -= 10; }
		    if (background_g > 9) { background_g -= 10; }
		    var background_s = 'background-color: #' + background_b + 'f' + background_g + 'fff;';
		    var match = goog.array.find(status_l, function(s_s) {
			    return (a.slice(0, 3) == s_s.slice(0, 3));
			});
		    if (match && (match.search('solved') > -1)) {
			status_s += '<span style="' + background_s + '">+</span>';
			    return;
		    }
		    if (match) {
			    status_s += '<span style="' + background_s + '">!</span>'; 
			    return;
		    }
		    status_s += '-'; 
		});
	    status_bar.innerHTML = status_s;
	    goog.dom.appendChild(put, d);
	})
    
};

ttg.dash.srp.handleError_ = function(payload) {
};

timer = new goog.Timer(1000 * 60);
timer.start();
goog.events.listen(timer, goog.Timer.TICK, ttg.dash.srp.send);

ttg.dash.srp.send();