import datetime
import fetcher # openid fetcher from google-app-engine-samples

from player import Player
import player
import logic
from google.appengine.ext import db
from google.appengine.ext import webapp
from google.appengine.ext.webapp.util import run_wsgi_app
from openid.consumer.consumer import Consumer

from django.utils import simplejson
import cgi
import openid.consumer.discover
import openid.fetchers
import re
import store # db store for openid from google-app-engine-samples
import time
import urllib
import urlparse
import gaeu.sessions

ACT_DATA = logic.ACT_DATA

BLANK_SCREEN = """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>2 Tone Game</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
  </head>
  <body>
    <center>
    <div class="titlebar">
    <h1>2 Tone Game</h1>

    <div id="hdr_checks">
    <img src="/s/stripe256.gif">
    </div>
    <script>
    document.getElementById("hdr_checks").innerHTML = '<iframe style="width: 100%; height: 32px; padding=0; margin=0; border: 0;" src="/s/stripe_frame.html">';
    </script>

    </div>

<center>
<p>Back to<br><a href="/">Top screen</a>
</center>

</body>
</html>
"""

LOGIN_SCREEN = """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>2 Tone Game: Sign In</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
  </head>
  <body>
    <center>
    <div class="titlebar">
    <h1>2 Tone Game: Sign In</h1>
   <div id="hdr_checks">
    <img src="/s/stripe256.gif">
    </div>
    <script>
    document.getElementById("hdr_checks").innerHTML = '<iframe style="width: 100%; height: 32px; padding=0; margin=0; border: 0;" src="/s/stripe_frame.html">';
    </script>

    </div>
</center>

<p style="text-align: right;" align=right><small><a href="/about/game">about</a></small>


<div align=center>
<p>The 2&nbsp;Tone Game uses 
   <a href="http://openid.net/get-an-openid/start-using-your-openid/">OpenID</a>


<p>&nbsp;

<form action="/openid-start" method="post" style="display:inline;">
<input type="hidden" name="openid_url" id="openid_url" value="https://www.google.com/accounts/o8/id" />
<input type="submit" value="Sign In" /> Sign in via Google
</form>

<p>or

<p><form action="/openid-start" method="post" style="display:inline;">
<input type="hidden" name="openid_url" id="openid_url" value="http://yahoo.com/"/>
<input type="submit" value="Sign In" /> Sign in via Yahoo!/flickr
</form><br>

<p>or

<p><form action="/openid-start" method="post">
<input type="submit" value="Sign In" />
<input type="text" name="openid_url" id="openid_url" value="http://" /><small><br>
E.g., http://<var>brad</var>.livejournal.com or http://<var>too</var>.blogspot.com
</small>
</form>

<p>&nbsp;

<p>The 2&nbsp;Tone Game does not collect<br>or share your private information.

<p>This is not a puzzle.  This is just signing in.

</div>

</body>
</html>"""

ADMIN_ACCOUNT_IDS = [
  "http://lahosken.san-francisco.ca.us",
]

class Log(db.Model):
  openid = db.StringProperty()
  act = db.StringProperty()
  action = db.StringProperty()
  label = db.StringProperty()
  created = db.DateTimeProperty(auto_now_add=True)

class SessionHandler(webapp.RequestHandler):
  def __init__(self):
    self.session = gaeu.sessions.Session(session_expire_time=345600) # 4 days
    return

class TopMain(SessionHandler):
  def get(self):
    self.response.headers['Content-Type'] = 'text/html'
    if 'openid_id' in self.session: 
      player = Player()
      player.LoadFromDBByID(self.session['openid_id'])
      self.response.out.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>2 Tone Game</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
  </head>
  <body>
    <center>
    <div class="titlebar">
    <h1>2 Tone Game</h1>

    <div id="hdr_checks">
    <img src="/s/stripe256.gif">
    </div>
    <script>
    document.getElementById("hdr_checks").innerHTML = '<iframe style="width: 100%; height: 32px; padding=0; margin=0; border: 0;" src="/s/stripe_frame.html">';
    </script>

    </div>
    <p style="text-align: right;" align=right><small><a href="/about/game">about</a></small>
    <p><b>Top Screen</b>
    <table><tr><td><td>
""")
      num_acts_showing = 0
      num_acts_solved = 0
      for a in logic.META_ORDER:
        # TODO n^2 looping: each getactstaus is a loop
        l = player.GetActStatus(a)
        if not l: continue
        num_acts_showing += 1
        (act, state, _, _, _) = l
        if state == "solved":
          num_acts_solved += 1
          soln = '<tt>' + ACT_DATA[act]["solved"] + '</tt>'
        else:
          soln = '<b>?</b>'
        self.response.out.write("""
  <tr><td><a href="/act/%(act)s/">%(act)s</a> 
      <td>%(soln)s
""" % {
            "act": act, 
            "state" : state,
            "soln" : soln,
})

      self.response.out.write("""
</ul>
</td></tr></table>""")
      if num_acts_showing < 6:
        self.response.out.write("""
      <p>This is a list of game activities you have "unlocked."
""")
      else:
        self.response.out.write("""

<p><b>Score</b>: %d

""" % player.score)
      if num_acts_solved == num_acts_showing:
        self.response.out.write("""
      <p>&nbsp;
      <p><img src="/s/stripe256.gif">
      <p><b>Congratulations!  You have solved all 
         of the puzzles!</b>  Hope you had fun!

      <p>You can use this form to taunt Game Control:

<form action="/msg" method="post" style="display:inline;">
<input name="msg" id="msg" value="" />
<input type="submit" value="Send" />
</form>

      <p>If you want a reply, remember to 
         leave contact info!
      <p><img src="/s/stripe256.gif">

      <p><a href="/about/credits">Credits</a>
""")
      self.response.out.write("""

</center>
</body>
</html>""")
    else:
      if 0:
        self.response.out.write(LOGIN_SCREEN)
        return
      for line in BLANK_SCREEN.split("\n"):
        if line.find("Back to") > -1: continue
        self.response.out.write(line)
      self.response.out.write("<center><h2>Coming Soon</h2></center> <p>&nbsp;")
      self.response.out.write("""
        <p>There's not much to see here now.<br>
           There will be more on April 10th at 10am.
      """)
      self.response.out.write("<p><a href=\"/about/game\">About</a>")

class ActMain(SessionHandler):
  def get(self, act_handle):
    self.response.headers['Content-Type'] = 'text/html'
    if 'openid_id' in self.session: 
      player = Player()
      player.LoadFromDBByID(self.session['openid_id'])
      try:
        (_, state, highest, points, last_updated) = player.GetActStatus(act_handle)
      except:
        self.response.out.write(BLANK_SCREEN)
        return
        
      hint_html = '<p><a href="/hint/%s/">Hints</a>' % act_handle
      for (hint_time, _) in ACT_DATA[act_handle]["hints"]:
        if hint_time > highest:
          minutes_since = (datetime.datetime.utcnow() - last_updated).seconds / 60
          points += minutes_since
          if points > hint_time:
            hint_html += " <b>Free hint available</b>"
          break
        
      self.response.out.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>2 Tone Game: %(act_handle)s</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
  </head>
  <body>
    <center>
    <div class="titlebar">
    <h1>%(act_handle)s</h1>

    <div id="hdr_checks">
    <img src="/s/stripe256.gif">
    </div>
    <script>
    document.getElementById("hdr_checks").innerHTML = '<iframe style="width: 100%%; height: 32px; padding=0; margin=0; border: 0;" src="/s/stripe_frame.html">';
    </script>

    </div>
    <p style="text-align: right;" align=right><small><a href="/about/game">about</a></small>


<p><a href="%(instructions)s">Instructions</a>
""" % {
          "act_handle": act_handle.capitalize(),
          "instructions": ACT_DATA[act_handle]["instructions"],
})
      if state == "solved":
        self.response.out.write("""
<p>Solution was <b>%(solution)s</b>

<p>Congratulations!!
""" % {
            "solution": ACT_DATA[act_handle]["solution"].upper(),
})
      else:
        self.response.out.write("""
<form action="/answer" method="post" style="display:inline;">
<input type="hidden" name="act" id="act" value="%(act_handle)s" />
<input name="answer" id="answer" value="" />
<input type="submit" value="Enter Guess" />
</form>

%(hint_html)s
""" % {
          "act_handle": act_handle,
          "hint_html": hint_html,
})
      self.response.out.write("""
      <p>Back to <a href="/">Top Screen</a>
</center>
""")

      return
    else:
      self.response.out.write(LOGIN_SCREEN)

def PackHintStatus(act, highest, points, last_updated_utcdatetime):
  date_s = last_updated_utcdatetime.strftime('%Y/%m/%d %H:%M:%S')
  return '%s\t%s\t%s\t%s' % (act, str(highest), str(points), date_s)

def UnpackHintStatus(s):
  (act, highest_s, points_s, date_s) = s.split('\t')
  date = datetime.datetime.strptime(date_s, '%Y/%m/%d %H:%M:%S')
  return (act, int(highest_s), int(points_s), date)

class HintMain(SessionHandler):
  # "helper function" that returns HTML string to display
  def display_helper(self, act_handle, player):
    bloblets = []
    bloblets.append("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>2 Tone Game: %(act_handle)s</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
  </head>
  <body>
    <center>
    <div class="titlebar">
    <h1>%(act_handle)s</h1>

    <div id="hdr_checks">
    <img src="/s/stripe256.gif">
    </div>
    <script>
    document.getElementById("hdr_checks").innerHTML = '<iframe style="width: 100%%; height: 32px; padding=0; margin=0; border: 0;" src="/s/stripe_frame.html">';
    </script>

    </div>

    <h2>Hints</h2>

""" % {
        "act_handle": act_handle.capitalize(),
        })
    # REMIND we find hint status here.  But in new scheme, I think caller
    #        already knows hint status.  So this is kind of a waste
    try:
      (_, state, highest, points, date) = player.GetActStatus(act_handle)
    except:
      # something strange is going on... 
      return """<p>Back to <a href="/">Top Screen</a>"""
    # REMIND revisit logic
    minutesSinceUpdate = (datetime.datetime.utcnow() - date).seconds / 60
    new_highest = -1
    for (hint_cost, hintText) in ACT_DATA[act_handle]['hints']:
      if hint_cost <= highest:
        bloblets.append("<p>" + hintText)
        continue
      if hint_cost <= points + minutesSinceUpdate + 100:
        bloblets.append("""
<form action="/hint/%(act_handle)s/" method="post" style="display:inline;">
<input type="hidden" name="cost" id="act" value="%(hint_cost)s" />
<input type="submit" value="Purchase hint" /> for <b>%(net_cost)s</b> points
</form>""" % {
            "act_handle": act_handle,
            "hint_cost":  str(hint_cost),
            "net_cost":  str(max(0, hint_cost - points - minutesSinceUpdate)),
            })
        break
    bloblets.append("""
   <p><a href="/act/%(act_handle)s/">Back</a>
</body>
</html>
""" % { "act_handle": act_handle, })
    return ("".join(bloblets), new_highest)
    
  def post(self, act_handle):
    self.response.headers['Content-Type'] = 'text/html'
    if 'openid_id' in self.session: 
      player = Player()
      player.LoadFromDBByID(self.session['openid_id'])
      try:
        (_, state, highest, points, last_updated) = player.GetActStatus(act_handle)
      except:
        self.response.out.write(BLANK_SCREEN)
        return
      try :
        cost = int(self.request.get('cost'))
      except:
        cost = 0
      player.PurchaseHint(act_handle, cost)
      player.Commit()
      log = Log(openid = self.session['openid_id'],
                action = "hint",
                act = act_handle,
                label = str(cost))
      log.put()
      (display_html, new_highest) = self.display_helper(act_handle, player)
      self.response.out.write(display_html)

  def get(self, act_handle):
    self.response.headers['Content-Type'] = 'text/html'
    if 'openid_id' in self.session: 
      player = Player()
      player.LoadFromDBByID(self.session['openid_id'])
      try:
        (_, state, highest, points, last_updated) = player.GetActStatus(act_handle)
      except:
        self.response.out.write(BLANK_SCREEN)
        return
        
      (display_html, new_highest) = self.display_helper(act_handle, player)
      self.response.out.write(display_html)

class AnswerMain(SessionHandler):
  def post(self):
    openid_id = self.session['openid_id']
    player = Player()
    player.LoadFromDBByID(self.session['openid_id'])
    try:
      act_raw = self.request.get('act')
    except:
      act_raw = "example"
    try:
      answer_raw = self.request.get('answer').lower()
    except:
      answer_raw = "iforgottotypesomething"
    act = "".join([c for c in act_raw if c.isalnum()])
    if not act in ACT_DATA: act = "example"
    answer = "".join([c for c in answer_raw if c.isalnum()])
    log = Log(openid = openid_id,
              action = "guess",
              act = act,
              label = answer)
    log.put()
    time.sleep(0.01)
    guesses = Log.all()
    guesses.filter("openid =", openid_id)
    guesses.filter("act =", act)
    guesses.filter("action =", "guess")
    five_minutes_ago = (datetime.datetime.now() + 
                        datetime.timedelta(minutes = -5))
    guesses.filter("created >", five_minutes_ago)
    guesses_l = guesses.fetch(500)
    delay = len(guesses_l)
    time.sleep(delay / 4)
    if not answer in ACT_DATA[act]["response"]:
      log = Log(openid = openid_id,
                action = "wtfguess",
                act = act,
                label = answer)
      log.put()
      self.response.out.write("""
<center>
<img src="/s/stripe256.gif">
<h1>That wasn't it</h1>

<p>You guessed <b>%(answer)s</b> but that was not the answer.
""" % { "answer": answer.upper() } )
      if delay > 5:
        self.response.out.write("""
<p style="background-color: #ffafaf;">
   You've made a few wrong guesses lately.  There will be a longer delay
   when we check future guesses.
""")
      self.response.out.write("""
</center>
<p><a href="/act/%(act)s/">Back</a>
""" % { "act": act } )
      return
    if ACT_DATA[act]["response"][answer][0]:
      player.BoostHint(act, ACT_DATA[act]["response"][answer][1])
      player.Commit()
      self.response.out.write("""
<center>
<img src="/s/stripe256.gif">
<center>
<h1>That wasn't it <br> <b style="background-color: #bfffbf;">BUT...</b></h1>

<p>You guessed <b>%(answer)s</b> but that was not the answer.

<p style="font-weight: bold; background-color: #bfffbf;">%(nudge)s
</center>

<p><a href="/act/%(act)s/">Back</a>
""" % { 
          "answer": answer.upper(),
          "nudge": ACT_DATA[act]["response"][answer][0],
          "act": act,
} )
      return
    (_, state, _, _, _) = player.GetActStatus(act)
    if state == "unlocked":
      player.MarkSolved(act)
      player.score += 100
      for a in logic.PickNextActs(player, datetime.datetime.utcnow()):
        player.UnlockAct(a)
        player.score += 100
        log = Log(openid = openid_id,
                  action = "unlock",
                  act = a,
                  label = "from " + act)
        log.put()
      player.Commit()
    self.response.out.write("<html><head><meta http-equiv=\"refresh\" content=\"0;url=/act/%s/\"></head><body></body></html>" % (act))

class MsgMain(SessionHandler):
  def post(self):
    openid_id = self.session['openid_id']
    player = Player()
    player.LoadFromDBByID(self.session['openid_id'])
    try:
      act_raw = self.request.get('act')
    except:
      act_raw = ""
    try:
      msg_raw = self.request.get('msg').lower()
    except:
      msg_raw = "msg"
    act = "".join([c for c in act_raw if c.isalnum()])
    if not act in ACT_DATA: act = ""
    msg = cgi.escape(msg_raw)
    log = Log(openid = openid_id,
              action = "msg",
              act = act,
              label = msg)
    log.put()
    self.response.out.write("""
<center>
<img src="/s/stripe256.gif">
<h1>Thanks for the message!</h1>

<p><b>You wrote</b> %(msg)s

<p>Depending on what else is going on, you might get a reply in 
   a few minutes, a few hours, or a few days!

</center>
<p><a href="/">Top Screen</a>
""" % { "msg": msg } )

class Dashboard(SessionHandler):
  def get(self):
    if not 'openid_id' in self.session: return
    if not self.session['openid_id'] in ADMIN_ACCOUNT_IDS: 
      self.response.out.write("""
         <p>I see OpenID %s
      """ % self.session['openid_id'])
      return
    self.response.out.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>Dashboard</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
    <script src="/s/dd.js"></script>
  </head>
  <body>
    <center>
    <h1>Dashboard</h1>

    <p><a href="/adm/log">recent logs</a>

    <table id="recent_teams">
    </table>

</body>
</html>
""")

class AdminPlayer(SessionHandler):
  def get(self):
    if not 'openid_id' in self.session: return
    if not self.session['openid_id'] in ADMIN_ACCOUNT_IDS: return
    id = self.request.get('id')
    if not id: return
    viewee = Player()
    viewee.LoadFromDBByID(id)

    now = datetime.datetime.utcnow().strftime('%Y/%m/%d %H:%M:%S')
    recent = viewee.recent.strftime('%Y/%m/%d %H:%M:%S')
    self.response.out.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>Player View %(id)s</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
    <style>
      td { padding: 5px; 0px; }
    </style>
  </head>
  <body>
    <div style="float: right; background-color: #fed; padding: 1em;">
    <a href="/dashboard.html">^</a><br>
    <a href="/adm/log?id=%(eid)s">p.logs</a><br>
    </div>
    <h1>Player View</h1>

    %(id)s


    <p>%(recent)s <b>Most Recent Activity</b>

    <p>%(now)s <b>Now</b>

    <p>%(score)d

    <p>%(status)s

""" % { "id": id, "score": viewee.score, "status": viewee.act_status, "now": now, "recent": recent, "eid": urllib.quote(id) })

    log_query = Log.all()
    log_query.filter("openid =", id)
    log_query.order("-created")
    logs = log_query.fetch(50)

    self.response.out.write("""<table>""")
    for log in logs:
      act = cgi.escape(log.act)
      action = cgi.escape(log.action)
      label = cgi.escape(log.label)
      created = log.created.strftime('%Y/%m/%d %H:%M:%S')
      self.response.out.write("""
<tr><td>%(act)s <td>%(action)s <td><b>%(label)s</b> <td>%(created)s
""" % { "act": act, "action": action,  "label": label, "created": created } )
    self.response.out.write("""</table>""")

    self.response.out.write("""

<center>
<p>Back to<br><a href="/">Top screen</a>
</center>

</body>
</html>
""")

class AdminLogs(SessionHandler):
  def get(self):
    if not 'openid_id' in self.session: return
    if not self.session['openid_id'] in ADMIN_ACCOUNT_IDS: return
    id = self.request.get('id')
    act = self.request.get('act')
    action = self.request.get('action')

    log_query = Log.all()
    if id: 
      log_query.filter("openid =", id)
    if act: 
      log_query.filter("act =", act)
    if action: 
      log_query.filter("action =", action)
    log_query.order("-created")
    logs = log_query.fetch(100)

    now = datetime.datetime.utcnow().strftime('%Y/%m/%d %H:%M:%S')

    self.response.out.write("""<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <title>Log View</title>
    <link href="/s/s.css" rel="stylesheet" type="text/css">
    <style>
      td { padding: 5px; 0px; }
    </style>
  </head>
  <body>
    <div style="float: right; background-color: #fed; padding: 1em;">
    <a href="/dashboard.html">^</a><br>
    </div>
    <h1>Log View</h1>

    <p>%(now)s <b>Now</b>

""" % { "now": now })
    if id:
      self.response.out.write("""<p><b>Player</b> <a href="/adm/pl?id=%s">%s</a>""" % (id, id))
    if act:
      self.response.out.write("""<p><b>Act</b> %s""" % act)
    if action:
      self.response.out.write("""<p><b>Action</b> %s""" % action)

    self.response.out.write("""<table>""")
    for log in logs:
      self.response.out.write("""<tr>""")
      if not id:
        color = ("ffffff" + "".join(re.findall('[A-Fa-f]+', log.openid)).lower())[-6:]
        self.response.out.write("""<td style="background-color: #%s;">%s""" % 
                                (color, log.openid))
      if not act:
        self.response.out.write("""<td>%s""" % log.act)
      if not action:
        self.response.out.write("""<td>%s""" % log.action)
      self.response.out.write("""<td>%s <td>%s""" % (log.label, log.created.strftime('%Y/%m/%d %H:%M:%S')))
      
class DashboardJson(webapp.RequestHandler):
  def get(self):
    stats = player.RecentStats()
    callback = self.request.get('callback')
    if callback:
      self.response.out.write(callback + '(')
    self.response.out.write(simplejson.dumps(stats))
    if callback:
      self.response.out.write(')')

class OpenIDStart(SessionHandler):
  def post(self):
    openid_url = self.request.get('openid_url')
    if not openid_url:
      self.report_error("Please enter an OpenID URL.")
      return
    try:
      openid.fetchers.setDefaultFetcher(fetcher.UrlfetchFetcher())
      s = {}
      consumer = Consumer(s, store.DatastoreStore())
      auth_request = consumer.begin(openid_url)
    except openid.consumer.discover.DiscoveryFailure, e:
      self.report_error('Error during OpenID provider discovery.', e)
      return
    except openid.consumer.discover.XRDSError, e:
      self.report_error('Error parsing XRDS from provider.', e)
      return

    self.session['openid_stuff'] = s
      
    parts = list(urlparse.urlparse(self.request.uri))
    parts[2] = 'openid-finish'
    parts[4] = ''
    parts[5] = ''
    return_to = urlparse.urlunparse(parts)

    realm = urlparse.urlunparse(parts[0:2] + [''] * 4)

    # send the redirect!  we use a meta because appengine bombs out
    # sometimes with long redirect urls
    redirect_url = auth_request.redirectURL(realm, return_to)
    self.response.out.write("<html><head><meta http-equiv=\"refresh\" content=\"0;url=%s\"></head><body></body></html>" % (redirect_url,))

class OpenIDFinish(SessionHandler):
  def get(self):
    args_as_dict = dict([(arg, self.request.get(arg)) for arg in self.request.arguments()])
    if 'openid_stuff' in self.session:
      s = self.session['openid_stuff']
    else:
      s = {}

    consumer = Consumer(s, store.DatastoreStore())

    auth_response = consumer.complete(args_as_dict,
                                      'http://' + self.request.host + 
                                      '/openid-finish')
    self.session['openid_stuff'] = s

    if auth_response.status == 'success':
      # openid = auth_response.getDisplayIdentifier()
      # persons = Person.gql('WHERE openid = :1', openid)
      # if persons.count() == 0:
      #   p = Person()
      #   p.openid = openid
      #   p.put()
      # else:
      #   p = persons[0]
      # 
      # s = self.get_session()
      # s.person = p.key()
      # self.logged_in_person = p
      # 
      # s.put()
      # 
      # self.session['openid_id'] = openid
      # for i in dir(auth_response):
      #   self.response.out.write(" " + i + "<br>\n")
      self.session['openid_id'] = auth_response.identity_url
      self.response.out.write("""
<html><head><meta http-equiv=\"refresh\" content=\"1;url=/\"></head>
<body>
<h1>Welcome</h1>
<p>You are logged in.  Soon you should see the <a href="/">top page</a>.
</body></html>
""")
    return

application = webapp.WSGIApplication(
  [('/', TopMain),
   (r'/act/([0-9A-Za-z]{1,100})/', ActMain),
   (r'/hint/([0-9A-Za-z]{1,100})/', HintMain),
   ('/dashboard.json', DashboardJson),
   ('/dashboard.html', Dashboard),
   ('/adm/pl', AdminPlayer),
   ('/adm/log', AdminLogs),
   ('/answer', AnswerMain),
   ('/msg', MsgMain),
   ('/openid-start', OpenIDStart),
   ('/openid-finish', OpenIDFinish),],
  debug=True)

def Main():
  run_wsgi_app(application)

  return

if __name__ == '__main__':
  Main()
